#include "Profiler.h"

int Profiler::numcalls[100];
double Profiler::totaltime[100];
LARGE_INTEGER Profiler::lastStartTime[100];

LARGE_INTEGER Profiler::timer;
LARGE_INTEGER Profiler::frequency;

void Profiler::init()
{
	timer.QuadPart=0;
	QueryPerformanceFrequency( &frequency ) ;
	
	for(int iii=0; iii<100; iii++) 
	{
		numcalls[iii] = 0;
		totaltime[iii] = 0.0;
	}
}

void Profiler::startcall(int func_id)
{
	QueryPerformanceCounter(&timer);
	lastStartTime[func_id] = timer;
	numcalls[func_id]++;			
}

void Profiler::endcall(int func_id)
{
	QueryPerformanceCounter(&timer);
			
	LARGE_INTEGER time;
	time.QuadPart = timer.QuadPart - lastStartTime[func_id].QuadPart;
	totaltime[func_id] += ((double)time.QuadPart /(double)frequency.QuadPart) ;
}
		
void Profiler::log(int detail)
{
	cout << "=================================================="<< endl;
	cout << "== Profiler Log:                               ==" << endl;
	cout << "=================================================="<< endl;
			
	for(int iii=0; iii<100; iii++)
	{
		if(numcalls[iii] > 0)
		{					
			if(iii<10) cout << "==   Function 0" << iii << "             = " << numcalls[iii] << " --> " << totaltime[iii] << endl;	
			if(iii>=10) cout << "==   Function " << iii <<  "             = " << numcalls[iii] << " --> " << totaltime[iii] << endl;	
		}
	}
			
	cout << "=================================================="<< endl;
	}